<template>
  <div class="model-binding-page">
    <fks-row :gutter="10" style="width:100%;height:100%;">
        <fks-col :span="4" style="width:220px;height:100%">
            <div class="model-binding-left-box">
                <titleBox title="金刚沱泵站"></titleBox>
                    <fks-tree
                    ref="tree"
                    :data="treeData"
                    :props="defaultProps"
                    :show-icon="true"
                    default-expand-all
                    node-key="id"
                    current-node-key="1-2"
                    :highlight-current="true"
                    >
                    </fks-tree>
            </div>
        </fks-col>
        <fks-col :span="20" style="width:calc(100% - 220px);height:100%;">
            <div class="model-binding-right-box">
                <titleBox title="1#电机"></titleBox>
                <fks-table 
                    border
                    max-height="700"
                    :data="TableData"
                    :span-method="arraySpanMethod"
                    style="width: 100%">
                    <fks-table-column
                        prop="point"
                        label="测点"
                        width="180">
                    </fks-table-column>
                    <fks-table-column
                        prop="signal"
                        label="信号"
                        width="180">
                    </fks-table-column>
                    <fks-table-column
                        prop="target"
                        label="指标">
                    </fks-table-column>
                    <fks-table-column
                        prop="dataType"
                        label="数据类型">
                    </fks-table-column>
                    <fks-table-column
                        prop="dataSources"
                        label="数据来源">
                    </fks-table-column><fks-table-column
                        prop="evaluationModel"
                        label="评价模型">
                    </fks-table-column>
                    <fks-table-column label="操作" width="80">
                        <template slot-scope="scope">
                            <fks-button
                            v-if="scope.row.target != '否'"
                            type="text"
                            size="mini"
                            @click="handleEdit(scope.$index, scope.row)">绑定</fks-button>
                        </template>
                    </fks-table-column>

               </fks-table>
            </div>
        </fks-col>
    </fks-row>

        <!--  选择指标评价模型 -->
        <fks-dialog
        title="选择指标评价模型"
        :visible.sync="bindDialogVisible"
        >
            <fks-table 
            border
            :data="evaluationModelTableData"
            style="width: 100%">
            <fks-table-column
                prop="name"
                label="名称"
                width="180">
            </fks-table-column>
            <fks-table-column
                prop="evaluationMethod"
                label="评价方法"
                width="180">
            </fks-table-column>
            <fks-table-column
                prop="evaluationParam"
                label="评价参数">
            </fks-table-column>
            <fks-table-column
                prop="desc"
                label="说明">
            </fks-table-column>
        </fks-table>
        <div slot="footer" class="dialog-footer">
            <fks-button @click="bindDialogVisible = false">取 消</fks-button>
            <fks-button type="primary" @click="bindDialogVisible = false">确 定</fks-button>
        </div>
    </fks-dialog>
  </div>
</template>

<script>
import titleBox from "@/views/main/components/titleBox.vue"
export default {
    components:{titleBox},
    data(){
        return {
            bindDialogVisible:false,
            treeData:[
                {
                    label: "泵站",
                    id:'s1',
                    children: [
                    {
                        id:'1',
                        label: "1#机组",
                        children:[
                            {
                            id:'1-1',
                            label: "1#泵",
                            },
                            {
                            id:'2-2',
                            label: "1#电机",
                            },
                        ],
                    },
                    {
                        id:'2',
                        label: "2#机组",
                        children:[
                            {
                            id:'2-1',
                            label: "2#泵",
                            },
                            {
                            id:'2-2',
                            label: "2#电机",
                            },
                        ],
                    },
                    {
                        id:'3',
                        label: "3#机组",
                        children:[
                            {
                            id:'3-1',
                            label: "3#泵",
                            },
                            {
                            id:'3-2',
                            label: "3#电机",
                            },
                        ],
                    },
                    {
                        id:'4',
                        label: "4#机组",
                        children:[
                            {
                            id:'4-1',
                            label: "4#泵",
                            },
                            {
                            id:'4-2',
                            label: "4#电机",
                            },
                        ],
                    },
                    ],
                },
            ],
            defaultProps: {
                children: "children",
                label: "label",
            },
            TableData:[
                {
                  point:"驱动端X方向振动",
                  signal:"有效值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:"振动加速度"
                },
                {
                  point:"驱动端X方向振动",
                  signal:"峭度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端X方向振动",
                  signal:"峰值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端X方向振动",
                  signal:"裕度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端X方向振动",
                  signal:"波形",
                  target:"否",
                  dataType:"数值",
                  dataSources:"对接",
                  evaluationModel:""
                },
                {
                  point:"驱动端Y方向",
                  signal:"有效值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:"振动加速度"
                },
                {
                  point:"驱动端Y方向",
                  signal:"峭度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Y方向",
                  signal:"峰值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Y方向",
                  signal:"裕度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Y方向",
                  signal:"波形",
                  target:"否",
                  dataType:"数值",
                  dataSources:"对接",
                  evaluationModel:""
                },
                {
                  point:"驱动端Z方向",
                  signal:"有效值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:"振动加速度"
                },
                {
                  point:"驱动端Z方向",
                  signal:"峭度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Z方向",
                  signal:"峰值",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Z方向",
                  signal:"裕度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"分析",
                  evaluationModel:""
                },
                {
                  point:"驱动端Z方向",
                  signal:"波形",
                  target:"否",
                  dataType:"数值",
                  dataSources:"对接",
                  evaluationModel:""
                },
                {
                  point:"轴承温度",
                  signal:"温度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"对接",
                  evaluationModel:"电机温度"
                },
                {
                  point:"绕组温度",
                  signal:"温度",
                  target:"是",
                  dataType:"数值",
                  dataSources:"对接",
                  evaluationModel:"电机温度"
                },
                {
                  point:"表面光滑度",
                  signal:"表面光滑度",
                  target:"是",
                  dataType:"文本",
                  dataSources:"录入",
                  evaluationModel:"电机表面光滑度"
                }
            ],
            showTableData:[],
            evaluationModelTableData:[
                {
                    name:"振动加速度",
                    evaluationMethod:"自动评价",
                    evaluationParam:"1.>=0.3 扣2分",
                    desc:"对振动波形中有效值进行扣分判定"
                },
                {
                    name:"电机温度",
                    evaluationMethod:"自动评价",
                    evaluationParam:"1.<=20 扣1分；2.>=60 扣5分",
                    desc:"电机温度过高，进行相应扣分"
                },
                {
                    name:"液位",
                    evaluationMethod:"自动评价",
                    evaluationParam:"3.<=7 扣 （x+7）*2分",
                    desc:"液位越低，扣分越多，需保持适度液位"
                },
                {
                    name:"电机表面光滑度",
                    evaluationMethod:"人工评价",
                    evaluationParam:"表面不光滑扣1分；有油污扣5分；有水渍扣5分；",
                    desc:"人工检查时，根据不同情况，进行手动评价"
                },
            ],
        }
    },
    mounted(){
        this.showTableData = JSON.parse(JSON.stringify(this.TableData))
        let tableData = this.showTableData
        this.getSpanArr(tableData,"point")
    },
    methods:{
        handleEdit(index,item){
            this.bindDialogVisible = true
        },
     // 计算 数据合并 索引
    getSpanArr(data, params) {
      // 接收重构数组
      let arr = [];
      // 设置索引
      let pos = 0;
      // 控制合并的数组
      this.rowSpanList = [];
      // arr 处理
      this.groupBy(data, params).map((v) => (arr = arr.concat(v)));
      arr.map((res) => {
        data.shift();
        data.push(res);
      });
      // rowSpanList 处理
      const redata = arr.map((v) => v[params]);
      redata.reduce((old, cur, i) => {
        // console.log(760, old, cur, i);
        if (i === 0) {
          this.rowSpanList.push(1);
          pos = 0;
        } else {
          if (cur === old) {
            this.rowSpanList[pos] += 1;
            this.rowSpanList.push(0);
          } else {
            this.rowSpanList.push(1);
            pos = i;
          }
        }
        return cur;
      }, {});
      // console.log(775, this.rowSpanList);
    },
    // 合并 tableData 数据
    arraySpanMethod({ rowIndex, columnIndex }) {
      if (this.rowSpanList.length != 0) {
        if (columnIndex === 0) {
          const _row = this.rowSpanList[rowIndex];
          const _col = _row > 0 ? 1 : 0;
          // console.log(_row,_col,454)
          return {
            rowspan: _row,
            colspan: _col,
          };
        }
      }
    },
    // groupBy 数组 用来将同一系列的泵归纳到一起
    groupBy(data, params) {
      const groups = {};
      data.forEach((v) => {
        const group = JSON.stringify(v[params]);
        groups[group] = groups[group] || [];
        groups[group].push(v);
      });
      return Object.values(groups);
    },
    }
}
</script>

<style scoped>
.model-binding-page{
    width: 100%;
    height: calc(100% - 0px);
}
.model-binding-left-box{
    width: 100%;
    height: 100%;
    background: #fff;

}
.model-binding-right-box{
    width:100%;
    height: 100%;
    background: #fff;
}
</style>